// lsqr_solve_lapack.h -*-c++-*-
#ifndef _lsqr_solve_lapack_HDR_
#define _lsqr_solve_lapack_HDR_

#include<boost/numeric/bindings/traits/ublas_matrix.hpp>
#include<boost/numeric/bindings/traits/ublas_vector.hpp>

#include<complex>

namespace pu {

    int const
    gels( boost::numeric::ublas::matrix<double,
	                                boost::numeric::ublas::column_major>
          &A,
	  boost::numeric::ublas::vector<double> &b,
	  boost::numeric::ublas::vector<double> &work );

    int const
    gels( boost::numeric::ublas::matrix< std::complex<double>,
	                                 boost::numeric::ublas::column_major >
          &A,
	  boost::numeric::ublas::vector<std::complex<double> > &b,
	  boost::numeric::ublas::vector<std::complex<double> > &work );


    int const
    gels( boost::numeric::ublas::matrix<double,
	                                boost::numeric::ublas::column_major>
          &A,
	  boost::numeric::ublas::matrix<double,
	                                boost::numeric::ublas::column_major>
	  &b,
	  boost::numeric::ublas::vector<double> &work );

    int const
    gels( boost::numeric::ublas::matrix< std::complex<double>,
	                                 boost::numeric::ublas::column_major >
          &A,
	  boost::numeric::ublas::matrix< std::complex<double>,
	                                 boost::numeric::ublas::column_major>
	  &b,
	  boost::numeric::ublas::vector<std::complex<double> > &work );


    int const gels_work_size( double const &dummy,
			      int const m, int const n, int const nrhs );
    int const gels_work_size( std::complex<double> const &dummy,
			      int const m, int const n, int const nrhs );



}

#endif
